from yac import Reg2dGrid, Location
import numpy as np


def gaussian_grid(
        name="Gaussian",
        lon_extent=[-np.pi, np.pi],
        lat_extent=[-np.pi/2, np.pi/2],
        resolution=[360, 180]):
    lon = np.linspace(*lon_extent, resolution[0])
    lat = np.linspace(*lat_extent, resolution[1])
    grid = Reg2dGrid(name,
                     lon, lat,
                     cyclic=[True, False])
    clon = lon+0.5*(lon[1]-lon[0])
    clat = 0.5*(lat[1:]+lat[:-1])
    return grid.def_points(Location.CELL, clon, clat)
