from mpi4py import MPI
from pytest import skip


def mpi_mpmd(*funcs):
    if MPI.COMM_WORLD.size < len(funcs):
        skip("Too few MPI processes")
    rank = MPI.COMM_WORLD.rank
    if rank < len(funcs):
        comm = MPI.COMM_WORLD.Split(0)
        funcs[rank](comm)
        comm.Free()
    else:
        MPI.COMM_WORLD.Split(MPI.UNDEFINED)
