from yac import YAC, Reg2dGrid, Location, Field, TimeUnit, Action, def_calendar, Calendar
import numpy as np
from grids.gaussian import gaussian_grid


def simple_source(comm,
                  comp_name="simple_comp",
                  grid_name="simple_grid",
                  field_names=["simple_field"]):
    def_calendar(Calendar.PROLEPTIC_GREGORIAN)
    yac = YAC(comm=comm)
    yac.def_datetime("2000-01-01T00:00:00", "2000-01-01T00:00:10")
    comp = yac.def_comp("simple_source")
    points = gaussian_grid(name=grid_name)
    fields = [Field.create(fn, comp, points, 1, "1", TimeUnit.SECOND)
              for fn in field_names]
    yac.enddef()
    i = 0
    while any(f.action != Action.OUT_OF_BOUND for f in fields):
        for f in fields:
            f.put(i*np.ones(points.size))
        i = i+1
