import numpy as np
from mpi_utils import mpi_mpmd
from simple_source import simple_source
from coyote import Coyote
from grids.gaussian import gaussian_grid


def coyote_print(comm):
    coyote = Coyote("simple_source",
                    "simple_grid",
                    comm=comm)
    points = gaussian_grid(name="print_grid")
    coyote.add_fields(["simple_field"], "PT1S", points, [{"nnn": {"n": 1}},
                                                         {"fixed":
                                                          {"user_value": -666}
                                                          }])
    for i, (name, data, info) in enumerate(coyote.start()):
        print(f"{name}: {info} {np.mean(data)=}")
        assert np.mean(data) == i


def test_simple():
    mpi_mpmd(simple_source, coyote_print)
